/*
One of those Weeks Episode 44: Alone in the Lab
Copyright (c) 2008,2011-2012 Blazing Games Inc.
Code written by Billy D. Spelchan

This program is free software; you can redistribute it and/or modify it under 
the terms of the GNU General Public License as published by the Free Software 
Foundation; either version 2 of the License, or (at your option) any later 
version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package com.blazinggames.ootw.ep44
{
	// Adobe Imports
	import flash.display.MovieClip;

	/**
	 * Tied to movieclip to hold a set of chemical colors. It is separate from
	 * the ChemicalStrip class to allow it to be used as part of the lab 
	 * machines display.
	 */
	public class ChemicalMix
	extends MovieClip
	{
// ***** CONSTANTS **********************************************************

		public static const NUM_CHEMS_ON_STRIP = 10;

// ***** VARIABLES **********************************************************

		private var _chemStack:Array;
		private var _numChems:int;

// ***** CONSTRUCTOR ********************************************************

		public function ChemicalMix()
		{
			_chemStack = new Array(
				_chem01_movie, _chem02_movie, _chem03_movie, _chem04_movie, 
				_chem05_movie, _chem06_movie, _chem07_movie, _chem08_movie,
				_chem09_movie, _chem10_movie);
			_numChems = 0;
			stop();
		}

// ***** Functions - General control ****************************************

		public function addChemical(n:int):void
		{
			if (_numChems < _chemStack.length) {
				_chemStack[_numChems].setChemical(n);
				++_numChems;
			}
		}
		
		public function getChemicalInSlot(slot:int):int
		{
			return _chemStack[slot].getChemical();
		}
		
		/**
		 * Counts the number of occurances of a particular chemical on the
		 * strip returning the count.
		 * 
		 * @param chemical Id of Chemical to check for
		 * @return number of occurances of the chemical
		 */
		public function getChemicalParts(chemical:int):int
		{
			var chemCount:int = 0;
			for (var cntr:int = 0; cntr < NUM_CHEMS_ON_STRIP; ++cntr)
				if (_chemStack[cntr].getChemical() == chemical)
					++chemCount;

			return chemCount;
		}
		
		public function clearMix():void
		{
			for (var cntr:int = 0; cntr < _chemStack.length; ++cntr)
				_chemStack[cntr].setChemical(0);
			_numChems = 0;
		}
	} // end class
} // end package
