/*
One of those Weeks Episode 44: Alone in the Lab
Copyright (c) 2008,2011-2012 Blazing Games Inc.
Code written by Billy D. Spelchan

This program is free software; you can redistribute it and/or modify it under 
the terms of the GNU General Public License as published by the Free Software 
Foundation; either version 2 of the License, or (at your option) any later 
version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package com.blazinggames.ootw.ep44
{
	// Adobe Imports
	import flash.display.MovieClip;

	/**
	 * Tied to movie clip. Image Strip used in game. Is able to validate
	 * a strip to see if it matches a key sequence.
	 */
	public class ChemicalStrip
	extends MovieClip
	{
// ***** CONSTANTS **********************************************************

// ***** VARIABLES **********************************************************

// ***** CONSTRUCTOR ********************************************************

		public function ChemicalStrip()
		{
			_mix_movie.clearMix();
			stop();
		}

// ***** Functions - General control ****************************************

		public function cloneMix(mix:ChemicalMix):void
		{
			_mix_movie.clearMix();
			for (var cntr:int = 0; cntr < ChemicalMix.NUM_CHEMS_ON_STRIP; ++cntr) {
				_mix_movie.addChemical(mix.getChemicalInSlot(cntr));
			}
		}
		
		/* pattern array is in pairs even=chem,odd=quantity */
		public function validateMix(pattern:Array):Boolean
		{
			var isValid = true;
			for (var cntr:int = 0; cntr < pattern.length; cntr += 2) {
				if (_mix_movie.getChemicalParts(pattern[cntr]) != pattern[cntr+1])
					isValid = false;
			}
			return isValid;
		}
	} // end class
} // end package

