/*
One of those Weeks Day 7
Copyright (c) 2007-2009, 2011-2012 Blazing Games Inc.
Code written by Billy D. Spelchan

This program is free software; you can redistribute it and/or modify it under 
the terms of the GNU General Public License as published by the Free Software 
Foundation; either version 2 of the License, or (at your option) any later 
version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package com.blazinggames.ootw.inventory
{
	// Adobe Imports
	import flash.display.Sprite;
	import flash.events.IEventDispatcher;

	/**
	* The inventory box actually holds the inventory items and lets the player
	* select items.
	*/
	public interface IInventoryBox
	{
// ***** Functions - IInventoryBox required *********************************

		/**
		* Adds the indicated item to the inventory box.
		*/
		function addInvItem(itm:IInventoryItem);
		
		/**
		* removes the indicated item from the inventory box.
		*/
		function removeInvItem(itm:IInventoryItem);
		
		/**
		* removes all the items from the inventory box.
		*/
		function clearInventory();
		
		/**
		* @returns array containing all items currently in the inventory box.
		*/
		function getInventoryList():Array;
		
		/**
		*@return The constant integer representing the current inventory state
		*/
		function getInventoryState():uint;

		/**
		* Sets the state of the inventory box. This is usually done internally
		* by the box, but could be done under the programs control to allow for
		* things such as keyboard shortcuts.
		*
		* @param theState inventory state constant from InventoryConst
		* @param if the state is select, then the item to select is needed
		* @param if the state is combine, then the item to combine is needed
		*/
		function setInventoryState(theState:uint, 
				theSelected:IInventoryItem = null,
				theSecondary:IInventoryItem = null);

		/**
		* @return the currently selected item, null if no item selected.
		*/
		function getSelectedItem():IInventoryItem;
		
		/**
		* @returns the item that is going to be combined with the selected
		* 		inventory item, with null being returned if none.
		*/
		function getSecondaryItem():IInventoryItem;
	}
}
